"""
Module to initialise connections to databases
"""

import psycopg2
import os
import yaml

class Connector:
    def __init__(self):
        self._connections = {}
        self.__LOCATION__ = os.path.dirname(__file__)
        self.CONNECTIONS_STRING = "host='{host}' dbname='{dbname}' user='{user}' password='{password}' port='{port}'"
        self.choice = {
                'sql': psycopg2.connect
            }
        with open(os.path.join(self.__LOCATION__, 'config.yaml'), 'r') as f:
            self.CONFIG = yaml.safe_load(f)
            
        self.CONFIG_conn = self.CONFIG['dbChoice']

    def get_connections(self, instance, db=None):
        """ Create connection or return active connection """
        if db:
            # Setup and return connections
            if isinstance(db, list):
                if isinstance(instance, list):
                    for k, v in zip(instance, db):
                        self._connections[k] = choice[k](v, CONFIG_conn.get(k))
                    print([self._connections[x] for x in instance])
                    return [self._connections[x] for x in instance]
                else:
                    raise Exception ('If db is a list then so should the instance be')
            else:
                self._connections[instance] = self.choice[instance](self.CONNECTIONS_STRING.format(**self.CONFIG_conn.get(instance), **{'dbname': db}))
                return self._connections[instance]
        else:
            # Get connections
            if isinstance(instance, list):
                return [self._connections[x] for x in instance]
            else:
                return self._connections[instance]
